Java 新人培训 — 异常处理

异常

异常不是编译时的错误(Error),异常是运行时错误(Exception)

 

异常处理流程


代码出现错误后,它会先在原函数代码内部寻找是否有try catch语句,如果没有,则找到调用这个函数的函数内部寻找,如果还没有就会交给java虚拟机,虚拟机会直接结束掉程序,返回异常信息.
如果异常交由 JVM 处理,JVM 会结束掉程序,并将异常信息输出到日志中,在 Android 上体现为 App 闪退。为了提高用户体验,我们要尽可能的处理可能发生的异常.

异常处理


  • try catch
public BufferedReader readFile(String path) {
        /*打开path指定路径下的文件
        * 可能抛出的异常 FileNotFoundException 文件不存在
        */
        FileInputStream fis = null;
        try {
            //可能出现错误的代码块
            fis = new FileInputStream(path);
        } catch (FileNotFoundException e) {
            //catch 可能出现的异常
            e.printStackTrace();//打印异常信息(函数调用栈)
        }
        BufferedReader brd = new BufferedReader(new InputStreamReader(fis));
        return brd;
    }

 

  • throws
    如果你不想自己处理可能发生的异常,throws 可以将异常抛给调用该方法的方法进行处理,如果是 main 方法,再抛出时就会交由虚拟机处理.
public BufferedReader readFile(String path) throws FileNotFoundException {
        FileInputStream fis = new FileInputStream(path);
        BufferedReader brd = new BufferedReader(new InputStreamReader(fis));
        return brd;
    }

 

异常的分类



如果抛出的异常为RuntimeException的子类,那么可以不进行捕获处理,如果是Exception的其它子类那么必须进行捕获处理,如果未进行捕获处理,但只要没有调用此方法,依然可以正常运行.
根据多态,如果你不能确定抛出的的异常类型,则可以 catch 它们的父类型 Exception

        try {
            //可能出现错误的代码块
            fis = new FileInputStream(path);
        } catch (Exception e) {
            //catch 可能出现的异常
            e.printStackTrace();//打印异常信息(函数调用栈)
        }

 

自定义异常


我们可以根据不同的业务需求,选择不同的父类,如 RuntimeException,Exception …

class LessMoneyException extends RuntimeException {
    public LessMoneyException(String s) {
        super(s);
    }
}

class TooMuchMoneyException extends Exception {
    public TooMuchMoneyException(String s) {
        super(s);
    }
}

当我们在发现代码执行过程中出现错误时,我们可以选择不去处理这个错误,而是throw(抛出)一个异常,让调用该函数的上下文来处理这个错误,这么做的原因通常是你再将自己实现的函数封装起来,供给他人使用,那么最好的办法不是自己处理异常,而是将异常抛给使用者,让他根据具体情况来处理错误.

public int foo2(ArrayList<Integer> list){
    if(list == null){
        throw new NullPointerException("list is null");
    }else {
        return list.size();
    }
}

 

注意事项


  1. 对于一个代码块来说,内部的语句在执行过程中可能会抛出多种异常,我们可以捕获不同类型的异常,针对具体问题做出不同的处理
public int foo1() {
    String a = null;
    String b = "20";
    String c = "0";
    int result = -1;
    try {
        result = Integer.valueOf(a) * Integer.valueOf(b) / Integer.valueOf(c);
    } catch (NumberFormatException e) {
        System.out.println("字符串转换整数错误,请检查被被转换字符串");
    } catch (ArithmeticException e) {
        System.out.println("出现了算术异常,可能为除零错误");
    }
    return result;
}

 
2. 当程序出现异常后,无论异常是否被处理,出现异常的代码后的语句都不再被执行,所以要注意因为异常导致的初始化及重置问题
如果你在 IDE 中编写了如下代码,在 return 语句出会出现错误提醒,因为 try 代码块中为可能出现异常的语句,则其内的赋值语句不一定会被成功执行,并不能确保变量一定被初始化,同时如果 i 变量的赋值出现问题,j 的赋值语句完全不会被执行.
Variable 'i' might not have been initialized

    public double foo2() {
        double i;
        double j;
        try {
            i = Math.PI;
            j = 1;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return i;
    }

 
3. 可以使用finally来对状态进行统一管理,如资源清除,变量重置,关闭打开的文件等

public void trans(int card1, int card2) {//从card1向card2转账1000
    int temp1 = card1, temp2 = card2;
    try {
        card1 -= 1000;
        if (card1 < 0) {
            throw new LessMoneyException("钱太少了");
        }
        card2 += 1000;
        if (card2 > 1001) {
            throw new TooMuchMoneyException("要那么多钱干嘛");
        }
    } catch (LessMoneyException e) {
        e.printStackTrace();
    } catch (TooMuchMoneyException e) {
        e.printStackTrace();
    } finally {
        card1 = temp1;
        card2 = temp2;
    }
}

发表评论

邮箱地址不会被公开。 必填项已用*标注